<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
   <modelVersion>4.0.0</modelVersion>

   <parent>
      <groupId>org.springframework.boot</groupId>
      <artifactId>spring-boot-starter-parent</artifactId>
      <version>2.2.0.RELEASE</version>
      <relativePath/>
   </parent>

   <groupId>pt.com</groupId>
   <artifactId>scrumify</artifactId>
   <version>1.5.431</version>
   <packaging>jar</packaging>

   <name>scrumify</name>
   <description>Scrumify is a management application for Scrum Teams who want a simple tool that makes their work easier.</description>
   <url>http://www.scrumify.com.pt</url>

   <developers>
      <developer>
         <id>esilverio</id>
         <name>Eduardo M. Silvério</name>
         <email>eduardo.m.silverio@accenture.com</email>
      </developer>
      <developer>
         <id>dverde</id>
         <name>Diogo M. Verde</name>
         <email>diogo.verde@accenture.com</email>
      </developer>
   </developers>

   <scm>
      <connection>scm:git:https://gitlab.com/eduardo.silverio/scrumify.git</connection>
      <developerConnection>scm:git:https://gitlab.com/eduardo.silverio/scrumify.git</developerConnection>
      <url>https://gitlab.com/eduardo.silverio/scrumify/tree/master</url>
   </scm>

   <ciManagement>
      <system>Jenkins</system>
      <url>http://jenkins.scrumify.com.pt:10091</url>
   </ciManagement>

   <issueManagement>
      <system>Gitlab</system>
      <url>https://gitlab.com/eduardo.silverio/scrumify/issues</url>
   </issueManagement>

   <properties>
      <java.version>11</java.version>
      <maven.version>3.3.9</maven.version>
      <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
      <timestamp>${maven.build.timestamp}</timestamp>

      <assertj.version>3.11.0</assertj.version>
      <commons.version>3.7</commons.version>
      <h2.version>1.4.200</h2.version>
      <joda-time.version>2.10</joda-time.version>
      <liquibase.version>3.8.0</liquibase.version>
      <mysql.version>8.0.13</mysql.version>
      <slf4j.version>1.7.25</slf4j.version>
      <swagger.version>2.9.2</swagger.version>

      <jacoco.version>0.8.5</jacoco.version>
      <jacoco.report.path>target/jacoco.exec</jacoco.report.path>
      <jacoco.minimum.coverage.limit>0</jacoco.minimum.coverage.limit>

      <sonar.projectKey>scrumify</sonar.projectKey>
      <sonar.java.binaries>/target</sonar.java.binaries>
      <sonar.exclusions>**/entities/**, **/database/entities/**, **/resources/db/**, **/resources/static/dependencies/**, **/resources/templates/javascripts/**, **/src/test/**</sonar.exclusions>
      <sonar.coverage.exclusions></sonar.coverage.exclusions>
      <code.coverage.exclusions></code.coverage.exclusions>

      <maven.plugin.version>3.7.0</maven.plugin.version>
      <sonar.plugin.version>3.7.0.1746</sonar.plugin.version>
      <cucumber.version>7.0.0</cucumber.version>
      <selenium.version>4.0.0</selenium.version>
      <guava.version>31.0.1-jre</guava.version>
      <assertj.version>3.21.0</assertj.version>
      <maven-surefire-plugin.version>3.0.0-M5</maven-surefire-plugin.version>
      <maven-surefire-plugin.configuration.includes/>
   </properties>

   <dependencyManagement>
      <dependencies>
         <dependency>
            <groupId>io.cucumber</groupId>
            <artifactId>cucumber-bom</artifactId>
            <version>${cucumber.version}</version>
            <type>pom</type>
            <scope>import</scope>
         </dependency>
         <dependency>
            <groupId>org.junit</groupId>
            <artifactId>junit-bom</artifactId>
            <version>5.8.1</version>
            <type>pom</type>
            <scope>import</scope>
         </dependency>
      </dependencies>
   </dependencyManagement>

   <profiles>
      <profile>
         <id>develop</id>
         <properties>
            <environment>develop</environment>
            <spring.profiles.active>develop</spring.profiles.active>

            <spring.datasource.driver>org.postgresql.Driver</spring.datasource.driver>
            <spring.datasource.url>jdbc:postgresql://postgres.devops.lab:10099/develop?currentSchema=${username}</spring.datasource.url>
            <spring.datasource.username>scrumify.develop</spring.datasource.username>
            <spring.datasource.password>devops.scrumify</spring.datasource.password>
            <spring.database.schema>${username}</spring.database.schema>
            <spring.liquibase.change-log>classpath:db/db.changelog-develop.yaml</spring.liquibase.change-log>
            <spring.liquibase.schema>${spring.database.schema}</spring.liquibase.schema>
         </properties>
         <distributionManagement>
            <repository>
               <id>releases.scrumify.lab</id>
               <name>Maven Repository for Releases</name>
               <url>http://nexus.devops.lab:10092/repository/applications-releases/</url>
            </repository>
            <snapshotRepository>
               <id>snapshots.scrumify.lab</id>
               <name>Maven Repository for Snapshots</name>
               <url>http://nexus.devops.lab:10092/repository/applications-snapshots/</url>
            </snapshotRepository>
         </distributionManagement>
      </profile>
      <profile>
         <id>dev</id>
         <properties>
            <environment>dev</environment>
            <spring.profiles.active>dev</spring.profiles.active>

            <spring.datasource.driver>org.postgresql.Driver</spring.datasource.driver>
            <spring.datasource.url>${env.DEV_DB_URL}</spring.datasource.url>
            <spring.datasource.username>${env.DEV_DB_USER}</spring.datasource.username>
            <spring.datasource.password>${env.DEV_DB_PASS}</spring.datasource.password>
            <spring.database.schema>scrumify</spring.database.schema>
            <spring.liquibase.change-log>classpath:db/db.changelog-cloud.yaml</spring.liquibase.change-log>
            <spring.liquibase.schema>${spring.database.schema}</spring.liquibase.schema>
         </properties>
      </profile>
      <profile>
         <id>qa</id>
         <properties>
            <environment>qa</environment>
            <spring.profiles.active>qa</spring.profiles.active>

            <spring.datasource.driver>org.postgresql.Driver</spring.datasource.driver>
            <spring.datasource.url>${env.QA_DB_URL}</spring.datasource.url>
            <spring.datasource.username>${env.QA_DB_USER}</spring.datasource.username>
            <spring.datasource.password>${env.QA_DB_PASS}</spring.datasource.password>
            <spring.database.schema>scrumify</spring.database.schema>
            <spring.liquibase.change-log>classpath:db/db.changelog-cloud.yaml</spring.liquibase.change-log>
            <spring.liquibase.schema>${spring.database.schema}</spring.liquibase.schema>
         </properties>
      </profile>
      <profile>
         <id>cloud</id>
         <properties>
            <environment>cloud</environment>
            <spring.profiles.active>cloud</spring.profiles.active>

            <spring.datasource.driver>org.postgresql.Driver</spring.datasource.driver>
            <spring.datasource.url>jdbc:postgresql://postgres.${env.BRANCH_NAME}.svc.cluster.local:5432/postgresdb?currentSchema=${spring.database.schema}</spring.datasource.url>
            <spring.datasource.username>postgresadmin</spring.datasource.username>
            <spring.datasource.password>admin123</spring.datasource.password>
            <spring.database.schema>scrumify</spring.database.schema>
            <spring.liquibase.change-log>classpath:db/db.changelog-cloud.yaml</spring.liquibase.change-log>
            <spring.liquibase.schema>${spring.database.schema}</spring.liquibase.schema>
         </properties>
      </profile>
      <profile>
         <id>testing</id>
         <properties>
            <environment>testing</environment>
            <spring.profiles.active>testing</spring.profiles.active>

            <spring.datasource.driver>org.postgresql.Driver</spring.datasource.driver>
            <spring.datasource.url>jdbc:postgresql://10.2.0.5:5432/postgresdb?currentSchema=${spring.database.schema}</spring.datasource.url>
            <spring.datasource.username>postgresadmin</spring.datasource.username>
            <spring.datasource.password>admin123</spring.datasource.password>
            <spring.database.schema>scrumify</spring.database.schema>
            <spring.liquibase.change-log>classpath:db/db.changelog-testing.yaml</spring.liquibase.change-log>
            <spring.liquibase.schema>${spring.database.schema}</spring.liquibase.schema>
         </properties>
         <distributionManagement>
            <repository>
               <id>releases.scrumify.lab</id>
               <name>Maven Repository for Releases</name>
               <url>http://nexus.devops.lab:10092/repository/applications-releases/</url>
            </repository>
            <snapshotRepository>
               <id>snapshots.scrumify.lab</id>
               <name>Maven Repository for Snapshots</name>
               <url>http://nexus.devops.lab:10092/repository/applications-snapshots/</url>
            </snapshotRepository>
         </distributionManagement>
      </profile>
      <profile>
         <id>staging</id>
         <properties>
            <environment>staging</environment>
            <spring.profiles.active>staging</spring.profiles.active>

            <spring.datasource.driver>org.postgresql.Driver</spring.datasource.driver>
            <spring.datasource.url>jdbc:postgresql://postgres.devops.lab:10099/staging?currentSchema=${spring.database.schema}</spring.datasource.url>
            <spring.datasource.username>scrumify.staging</spring.datasource.username>
            <spring.datasource.password>devops.scrumify</spring.datasource.password>
            <spring.database.schema>scrumify</spring.database.schema>
            <spring.liquibase.change-log>classpath:db/db.changelog-staging.yaml</spring.liquibase.change-log>
            <spring.liquibase.schema>${spring.database.schema}</spring.liquibase.schema>
         </properties>
         <distributionManagement>
            <repository>
               <id>releases.scrumify.lab</id>
               <name>Maven Repository for Releases</name>
               <url>http://nexus.devops.lab:10092/repository/applications-releases/</url>
            </repository>
            <snapshotRepository>
               <id>snapshots.scrumify.lab</id>
               <name>Maven Repository for Snapshots</name>
               <url>http://nexus.devops.lab:10092/repository/applications-snapshots/</url>
            </snapshotRepository>
         </distributionManagement>
      </profile>
      <profile>
         <id>release</id>
         <properties>
            <environment>release</environment>
            <spring.profiles.active>release</spring.profiles.active>

            <spring.datasource.driver>org.postgresql.Driver</spring.datasource.driver>
            <spring.datasource.url>jdbc:postgresql://scrumify.ddns.net:10099/postgres?currentSchema=${spring.database.schema}</spring.datasource.url>
            <spring.datasource.username>scrumify</spring.datasource.username>
            <spring.datasource.password>devops.scrumify</spring.datasource.password>
            <spring.database.schema>scrumify</spring.database.schema>
            <spring.liquibase.change-log>classpath:db/db.changelog-release.yaml</spring.liquibase.change-log>
            <spring.liquibase.schema>${spring.database.schema}</spring.liquibase.schema>
         </properties>
         <distributionManagement>
            <repository>
               <id>releases.scrumify.lab</id>
               <name>Maven Repository for Releases</name>
               <url>http://nexus.devops.lab:10092/repository/applications-releases/</url>
            </repository>
            <snapshotRepository>
               <id>snapshots.scrumify.lab</id>
               <name>Maven Repository for Snapshots</name>
               <url>http://nexus.devops.lab:10092/repository/applications-snapshots/</url>
            </snapshotRepository>
         </distributionManagement>
      </profile>
      <profile>
         <id>unit</id>
         <properties>
            <maven-surefire-plugin.configuration.groups>unit</maven-surefire-plugin.configuration.groups>
         </properties>
      </profile>
      <profile>
         <id>smoke</id>
         <properties>
            <maven-surefire-plugin.configuration.groups>smoke</maven-surefire-plugin.configuration.groups>
         </properties>
      </profile>
      <profile>
         <id>integration</id>
         <properties>
            <maven-surefire-plugin.configuration.groups>integration</maven-surefire-plugin.configuration.groups>
         </properties>
      </profile>
      <profile>
         <id>cucumber</id>
         <properties>
            <maven-surefire-plugin.configuration.groups>integration</maven-surefire-plugin.configuration.groups>
            <maven-surefire-plugin.configuration.includes>**/features/*</maven-surefire-plugin.configuration.includes>
         </properties>
      </profile>
   </profiles>

   <dependencies>
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-web</artifactId>
      </dependency>
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-thymeleaf</artifactId>
      </dependency>
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-tomcat</artifactId>
         <scope>provided</scope>
      </dependency>
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-security</artifactId>
      </dependency>
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-data-jpa</artifactId>
      </dependency>
      <dependency>
         <groupId>org.thymeleaf.extras</groupId>
         <artifactId>thymeleaf-extras-springsecurity5</artifactId>
      </dependency>
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-cache</artifactId>
      </dependency>
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-mail</artifactId>
      </dependency>
      <dependency>
         <groupId>org.postgresql</groupId>
         <artifactId>postgresql</artifactId>
      </dependency>
      <dependency>
         <groupId>commons-io</groupId>
         <artifactId>commons-io</artifactId>
         <version>2.6</version>
      </dependency>
      <dependency>
         <groupId>org.apache.commons</groupId>
         <artifactId>commons-lang3</artifactId>
      </dependency>
      <dependency>
         <groupId>joda-time</groupId>
         <artifactId>joda-time</artifactId>
      </dependency>
      <dependency>
         <groupId>io.springfox</groupId>
         <artifactId>springfox-swagger2</artifactId>
         <version>${swagger.version}</version>
      </dependency>
      <dependency>
         <groupId>io.springfox</groupId>
         <artifactId>springfox-swagger-ui</artifactId>
         <version>${swagger.version}</version>
      </dependency>
      <dependency>
         <groupId>io.springfox</groupId>
         <artifactId>springfox-bean-validators</artifactId>
         <version>${swagger.version}</version>
      </dependency>
      <dependency>
         <groupId>org.liquibase</groupId>
         <artifactId>liquibase-core</artifactId>
      </dependency>
      <dependency>
         <groupId>org.liquibase</groupId>
         <artifactId>liquibase-maven-plugin</artifactId>
         <version>${liquibase.version}</version>
      </dependency>
      <!--      <dependency>-->
      <!--         <groupId>org.slf4j</groupId>-->
      <!--         <artifactId>slf4j-api</artifactId>-->
      <!--      </dependency>-->
      <dependency>
         <groupId>org.projectlombok</groupId>
         <artifactId>lombok</artifactId>
         <optional>true</optional>
      </dependency>
      <dependency>
         <groupId>org.apache.poi</groupId>
         <artifactId>poi-ooxml</artifactId>
         <version>4.1.0</version>
      </dependency>
      <dependency>
         <groupId>org.hibernate</groupId>
         <artifactId>hibernate-search-orm</artifactId>
         <version>5.11.2.Final</version>
      </dependency>
      <dependency>
         <groupId>com.google.code.gson</groupId>
         <artifactId>gson</artifactId>
      </dependency>
      <dependency>
         <groupId>org.jsoup</groupId>
         <artifactId>jsoup</artifactId>
         <version>1.13.1</version>
      </dependency>
      <!-- START -->
      <!-- testing a different lib to use Word docx -->
      <dependency>
         <groupId>org.docx4j</groupId>
         <artifactId>docx4j</artifactId>
         <version>6.1.2</version>
      </dependency>
      <dependency>
         <groupId>org.docx4j</groupId>
         <artifactId>docx4j-ImportXHTML</artifactId>
         <version>8.0.0</version>
      </dependency>
      <!-- END -->
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-actuator</artifactId>
      </dependency>
      <dependency>
         <groupId>io.micrometer</groupId>
         <artifactId>micrometer-core</artifactId>
      </dependency>
      <dependency>
         <groupId>io.micrometer</groupId>
         <artifactId>micrometer-registry-prometheus</artifactId>
      </dependency>

      <!-- TEST DEPENDENCIES -->
      <dependency>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-test</artifactId>
         <scope>test</scope>
         <exclusions>
            <exclusion>
               <groupId>org.junit.vintage</groupId>
               <artifactId>junit-vintage-engine</artifactId>
            </exclusion>
         </exclusions>
      </dependency>
      <dependency>
         <groupId>org.springframework.security</groupId>
         <artifactId>spring-security-test</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>org.assertj</groupId>
         <artifactId>assertj-core</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>io.cucumber</groupId>
         <artifactId>cucumber-junit-platform-engine</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>io.cucumber</groupId>
         <artifactId>cucumber-java</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>io.cucumber</groupId>
         <artifactId>cucumber-junit</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>io.cucumber</groupId>
         <artifactId>cucumber-spring</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>org.junit.platform</groupId>
         <artifactId>junit-platform-suite</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>org.junit.jupiter</groupId>
         <artifactId>junit-jupiter</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>org.junit.jupiter</groupId>
         <artifactId>junit-jupiter-engine</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>org.seleniumhq.selenium</groupId>
         <artifactId>selenium-java</artifactId>
         <scope>test</scope>
         <exclusions>
            <exclusion>
               <groupId>com.google.guava</groupId>
               <artifactId>guava</artifactId>
            </exclusion>
         </exclusions>
      </dependency>
      <dependency>
         <groupId>org.seleniumhq.selenium</groupId>
         <artifactId>selenium-api</artifactId>
         <scope>test</scope>
      </dependency>
      <dependency>
         <groupId>org.seleniumhq.selenium</groupId>
         <artifactId>selenium-chrome-driver</artifactId>
         <scope>test</scope>
         <exclusions>
            <exclusion>
               <groupId>com.google.guava</groupId>
               <artifactId>guava</artifactId>
            </exclusion>
         </exclusions>
      </dependency>
      <dependency>
         <groupId>com.google.guava</groupId>
         <artifactId>guava</artifactId>
         <version>${guava.version}</version>
      </dependency>
      <dependency>
         <groupId>com.icegreen</groupId>
         <artifactId>greenmail-junit5</artifactId>
         <version>1.6.5</version>
         <scope>test</scope>
         <exclusions>
            <exclusion>
               <groupId>org.slf4j</groupId>
               <artifactId>slf4j-api</artifactId>
            </exclusion>
            <exclusion>
               <groupId>junit</groupId>
               <artifactId>junit</artifactId>
            </exclusion>
         </exclusions>
      </dependency>
   </dependencies>

   <build>
      <plugins>
         <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-surefire-plugin</artifactId>
            <version>${maven-surefire-plugin.version}</version>
            <configuration>
               <!--suppress UnresolvedMavenProperty -->
               <groups>${maven-surefire-plugin.configuration.groups}</groups>
               <includes><include>${maven-surefire-plugin.configuration.includes}</include></includes>
            </configuration>
         </plugin>
         <plugin>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-maven-plugin</artifactId>
         </plugin>
         <plugin>
            <groupId>org.codehaus.mojo</groupId>
            <artifactId>versions-maven-plugin</artifactId>
            <configuration>
               <generateBackupPoms>false</generateBackupPoms>
            </configuration>
         </plugin>
         <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-compiler-plugin</artifactId>
            <configuration>
               <release>${java.version}</release>
               <source>${java.version}</source>
               <target>${java.version}</target>
            </configuration>
         </plugin>
         <plugin>
            <groupId>org.sonarsource.scanner.maven</groupId>
            <artifactId>sonar-maven-plugin</artifactId>
            <version>${sonar.plugin.version}</version>
         </plugin>
         <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-enforcer-plugin</artifactId>
            <executions>
               <execution>
                  <id>enforce-maven</id>
                  <goals>
                     <goal>enforce</goal>
                  </goals>
                  <configuration>
                     <rules>
                        <requireMavenVersion>
                           <version>${maven.version}</version>
                        </requireMavenVersion>
                     </rules>
                  </configuration>
               </execution>
            </executions>
         </plugin>
         <plugin>
            <groupId>com.amashchenko.maven.plugin</groupId>
            <artifactId>gitflow-maven-plugin</artifactId>
            <version>1.13.0</version>
            <configuration>
               <gitFlowConfig>
                  <productionBranch>master</productionBranch>
                  <developmentBranch>develop</developmentBranch>
                  <featureBranchPrefix>feature/</featureBranchPrefix>
                  <releaseBranchPrefix>release/</releaseBranchPrefix>
                  <hotfixBranchPrefix>hotfix/</hotfixBranchPrefix>
                  <supportBranchPrefix>support/</supportBranchPrefix>
                  <versionTagPrefix>v</versionTagPrefix>
                  <origin>origin</origin>
               </gitFlowConfig>
               <verbose>true</verbose>
            </configuration>
         </plugin>
         <plugin>
            <groupId>org.liquibase</groupId>
            <artifactId>liquibase-maven-plugin</artifactId>
            <version>${liquibase.version}</version>
            <configuration>
               <changeLogFile>src/main/resources/${spring.liquibase.change-log}</changeLogFile>
               <driver>${spring.datasource.driver}</driver>
               <url>${spring.datasource.url}</url>
               <server>db.scrumify.com.pt</server>
               <schemas>${database.schema}</schemas>
               <promptOnNonLocalDatabase>false</promptOnNonLocalDatabase>
            </configuration>
         </plugin>
         <plugin>
            <groupId>org.jacoco</groupId>
            <artifactId>jacoco-maven-plugin</artifactId>
            <version>${jacoco.version}</version>
            <executions>
               <execution>
                  <goals>
                     <goal>prepare-agent</goal>
                  </goals>
               </execution>
               <execution>
                  <id>post-unit-test</id>
                  <phase>test</phase>
                  <goals>
                     <goal>report</goal>
                  </goals>
               </execution>
               <execution>
                  <id>jacoco-check</id>
                  <phase>test</phase>
                  <goals>
                     <goal>check</goal>
                  </goals>
               </execution>
            </executions>
            <configuration>
               <rules>
                  <rule implementation="org.jacoco.maven.RuleConfiguration">
                     <element>BUNDLE</element>
                     <limits>
                        <limit implementation="org.jacoco.report.check.Limit">
                           <counter>COMPLEXITY</counter>
                           <value>COVEREDRATIO</value>
                           <minimum>${jacoco.minimum.coverage.limit}</minimum>
                        </limit>
                     </limits>
                  </rule>
               </rules>
               <excludes>${code.coverage.exclusions}</excludes>
            </configuration>
         </plugin>
      </plugins>

      <resources>
         <resource>
            <directory>src/main/resources</directory>
            <filtering>true</filtering>
            <includes>
               <include>**/*.properties</include>
            </includes>
         </resource>
         <resource>
            <directory>src/main/resources</directory>
            <filtering>false</filtering>
            <excludes>
               <exclude>**/*.properties</exclude>
            </excludes>
         </resource>
      </resources>
   </build>
</project>

